/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsISHistory.idl
 */

#ifndef __gen_nsISHistory_h__
#define __gen_nsISHistory_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIFactory_h__
#include "nsIFactory.h"
#endif

#ifndef __gen_nsISHEntry_h__
#include "nsISHEntry.h"
#endif

#ifndef __gen_nsISHTransaction_h__
#include "nsISHTransaction.h"
#endif

#ifndef __gen_nsIDocShell_h__
#include "nsIDocShell.h"
#endif

#ifndef __gen_nsISHistoryListener_h__
#include "nsISHistoryListener.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
#define NS_SHISTORY_CID \
{0xdd335421, 0xb8b8, 0x11d3, {0xbd, 0xc8, 0x00, 0x50, 0x04, 0x0a, 0x9b, 0x44}}
#define NS_SHISTORY_CONTRACTID "@mozilla.org/browser/shistory;1"

/* starting interface:    nsISHistory */
#define NS_ISHISTORY_IID_STR "dd335421-b8b8-11d3-bdc8-0050040a9b44"

#define NS_ISHISTORY_IID \
  {0xdd335421, 0xb8b8, 0x11d3, \
    { 0xbd, 0xc8, 0x00, 0x50, 0x04, 0x0a, 0x9b, 0x44 }}

class NS_NO_VTABLE nsISHistory : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISHISTORY_IID)

  /**
   * Add a new Entry to the History List
	 * @param aEntry - The entry to add
	 * @param aPersist - If true this specifies that the entry should persist
	 * in the list.  If false, this means that when new entries are added
	 * this element will not appear in the session history list.
   */
  /* void addEntry (in nsISHEntry aEntry, in boolean aPersist); */
  NS_IMETHOD AddEntry(nsISHEntry *aEntry, PRBool aPersist) = 0;

  /**
   * Get the size of the History list
   */
  /* readonly attribute long count; */
  NS_IMETHOD GetCount(PRInt32 *aCount) = 0;

  /**
   * Get the index of the current document in the history list
   */
  /* readonly attribute long index; */
  NS_IMETHOD GetIndex(PRInt32 *aIndex) = 0;

  /** 
   * Get Previous Entry
   */
  /* nsISHEntry getPreviousEntry (in boolean modifyIndex); */
  NS_IMETHOD GetPreviousEntry(PRBool modifyIndex, nsISHEntry **_retval) = 0;

  /**
   * Get the next entry
   */
  /* nsISHEntry getNextEntry (in boolean modifyIndex); */
  NS_IMETHOD GetNextEntry(PRBool modifyIndex, nsISHEntry **_retval) = 0;

  /**
   * Get the entry at a given index
   */
  /* nsISHEntry getEntryAtIndex (in long index, in boolean modifyIndex); */
  NS_IMETHOD GetEntryAtIndex(PRInt32 index, PRBool modifyIndex, nsISHEntry **_retval) = 0;

  /**
   * Get the root transaction
   */
  /* readonly attribute nsISHTransaction rootTransaction; */
  NS_IMETHOD GetRootTransaction(nsISHTransaction * *aRootTransaction) = 0;

  /**
   * The toplevel docshell object to which this SHistory object belongs to.
   */
  /* attribute nsIDocShell rootDocShell; */
  NS_IMETHOD GetRootDocShell(nsIDocShell * *aRootDocShell) = 0;
  NS_IMETHOD SetRootDocShell(nsIDocShell * aRootDocShell) = 0;

  /**
   * Get/Set the Max entries Session History will hold per window
   */
  /* attribute long maxLength; */
  NS_IMETHOD GetMaxLength(PRInt32 *aMaxLength) = 0;
  NS_IMETHOD SetMaxLength(PRInt32 aMaxLength) = 0;

  /**
   * Purge the oldest numEntries from history list
   */
  /* void PurgeHistory (in long numEntries); */
  NS_IMETHOD PurgeHistory(PRInt32 numEntries) = 0;

  /**
   * Register a Session History Listener to be notified on SHistory events
   */
  /* void addSHistoryListener (in nsISHistoryListener aListener); */
  NS_IMETHOD AddSHistoryListener(nsISHistoryListener *aListener) = 0;

  /**
   * Remove a previously registered Session History Listener 
   */
  /* void removeSHistoryListener (in nsISHistoryListener aListener); */
  NS_IMETHOD RemoveSHistoryListener(nsISHistoryListener *aListener) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISHISTORY \
  NS_IMETHOD AddEntry(nsISHEntry *aEntry, PRBool aPersist); \
  NS_IMETHOD GetCount(PRInt32 *aCount); \
  NS_IMETHOD GetIndex(PRInt32 *aIndex); \
  NS_IMETHOD GetPreviousEntry(PRBool modifyIndex, nsISHEntry **_retval); \
  NS_IMETHOD GetNextEntry(PRBool modifyIndex, nsISHEntry **_retval); \
  NS_IMETHOD GetEntryAtIndex(PRInt32 index, PRBool modifyIndex, nsISHEntry **_retval); \
  NS_IMETHOD GetRootTransaction(nsISHTransaction * *aRootTransaction); \
  NS_IMETHOD GetRootDocShell(nsIDocShell * *aRootDocShell); \
  NS_IMETHOD SetRootDocShell(nsIDocShell * aRootDocShell); \
  NS_IMETHOD GetMaxLength(PRInt32 *aMaxLength); \
  NS_IMETHOD SetMaxLength(PRInt32 aMaxLength); \
  NS_IMETHOD PurgeHistory(PRInt32 numEntries); \
  NS_IMETHOD AddSHistoryListener(nsISHistoryListener *aListener); \
  NS_IMETHOD RemoveSHistoryListener(nsISHistoryListener *aListener); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISHISTORY(_to) \
  NS_IMETHOD AddEntry(nsISHEntry *aEntry, PRBool aPersist) { return _to ## AddEntry(aEntry, aPersist); } \
  NS_IMETHOD GetCount(PRInt32 *aCount) { return _to ## GetCount(aCount); } \
  NS_IMETHOD GetIndex(PRInt32 *aIndex) { return _to ## GetIndex(aIndex); } \
  NS_IMETHOD GetPreviousEntry(PRBool modifyIndex, nsISHEntry **_retval) { return _to ## GetPreviousEntry(modifyIndex, _retval); } \
  NS_IMETHOD GetNextEntry(PRBool modifyIndex, nsISHEntry **_retval) { return _to ## GetNextEntry(modifyIndex, _retval); } \
  NS_IMETHOD GetEntryAtIndex(PRInt32 index, PRBool modifyIndex, nsISHEntry **_retval) { return _to ## GetEntryAtIndex(index, modifyIndex, _retval); } \
  NS_IMETHOD GetRootTransaction(nsISHTransaction * *aRootTransaction) { return _to ## GetRootTransaction(aRootTransaction); } \
  NS_IMETHOD GetRootDocShell(nsIDocShell * *aRootDocShell) { return _to ## GetRootDocShell(aRootDocShell); } \
  NS_IMETHOD SetRootDocShell(nsIDocShell * aRootDocShell) { return _to ## SetRootDocShell(aRootDocShell); } \
  NS_IMETHOD GetMaxLength(PRInt32 *aMaxLength) { return _to ## GetMaxLength(aMaxLength); } \
  NS_IMETHOD SetMaxLength(PRInt32 aMaxLength) { return _to ## SetMaxLength(aMaxLength); } \
  NS_IMETHOD PurgeHistory(PRInt32 numEntries) { return _to ## PurgeHistory(numEntries); } \
  NS_IMETHOD AddSHistoryListener(nsISHistoryListener *aListener) { return _to ## AddSHistoryListener(aListener); } \
  NS_IMETHOD RemoveSHistoryListener(nsISHistoryListener *aListener) { return _to ## RemoveSHistoryListener(aListener); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsSHistory : public nsISHistory
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSISHISTORY

  nsSHistory();
  virtual ~nsSHistory();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsSHistory, nsISHistory)

nsSHistory::nsSHistory()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsSHistory::~nsSHistory()
{
  /* destructor code */
}

/* void addEntry (in nsISHEntry aEntry, in boolean aPersist); */
NS_IMETHODIMP nsSHistory::AddEntry(nsISHEntry *aEntry, PRBool aPersist)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long count; */
NS_IMETHODIMP nsSHistory::GetCount(PRInt32 *aCount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long index; */
NS_IMETHODIMP nsSHistory::GetIndex(PRInt32 *aIndex)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsISHEntry getPreviousEntry (in boolean modifyIndex); */
NS_IMETHODIMP nsSHistory::GetPreviousEntry(PRBool modifyIndex, nsISHEntry **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsISHEntry getNextEntry (in boolean modifyIndex); */
NS_IMETHODIMP nsSHistory::GetNextEntry(PRBool modifyIndex, nsISHEntry **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsISHEntry getEntryAtIndex (in long index, in boolean modifyIndex); */
NS_IMETHODIMP nsSHistory::GetEntryAtIndex(PRInt32 index, PRBool modifyIndex, nsISHEntry **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsISHTransaction rootTransaction; */
NS_IMETHODIMP nsSHistory::GetRootTransaction(nsISHTransaction * *aRootTransaction)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIDocShell rootDocShell; */
NS_IMETHODIMP nsSHistory::GetRootDocShell(nsIDocShell * *aRootDocShell)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSHistory::SetRootDocShell(nsIDocShell * aRootDocShell)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute long maxLength; */
NS_IMETHODIMP nsSHistory::GetMaxLength(PRInt32 *aMaxLength)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSHistory::SetMaxLength(PRInt32 aMaxLength)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void PurgeHistory (in long numEntries); */
NS_IMETHODIMP nsSHistory::PurgeHistory(PRInt32 numEntries)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addSHistoryListener (in nsISHistoryListener aListener); */
NS_IMETHODIMP nsSHistory::AddSHistoryListener(nsISHistoryListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeSHistoryListener (in nsISHistoryListener aListener); */
NS_IMETHODIMP nsSHistory::RemoveSHistoryListener(nsISHistoryListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsISHistory_h__ */
