/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIStreamObserver.idl
 */

#ifndef __gen_nsIStreamObserver_h__
#define __gen_nsIStreamObserver_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIRequest; /* forward declaration */

class nsIEventQueue; /* forward declaration */


/* starting interface:    nsIStreamObserver */
#define NS_ISTREAMOBSERVER_IID_STR "fd91e2e0-1481-11d3-9333-00104ba0fd40"

#define NS_ISTREAMOBSERVER_IID \
  {0xfd91e2e0, 0x1481, 0x11d3, \
    { 0x93, 0x33, 0x00, 0x10, 0x4b, 0xa0, 0xfd, 0x40 }}

class NS_NO_VTABLE nsIStreamObserver : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISTREAMOBSERVER_IID)

  /**
     * Called to signify the beginning of an asynchronous request.
     *
     * @param request - request being observed
     * @param ctxt - user specified data passed to AsyncRead/Write
     */
  /* void onStartRequest (in nsIRequest request, in nsISupports ctxt); */
  NS_IMETHOD OnStartRequest(nsIRequest *request, nsISupports *ctxt) = 0;

  /**
     * Called to signify the end of an asynchronous request.  This
     * call is always preceded by a call to onStartRequest.
     *
     * @param request - request being observed
     * @param ctxt - user specified data passed to AsyncRead/Write
     * @param statusCode - reason for stopping (NS_OK if completed successfully)
     * @param statusText - human readable reason for stopping (can be NULL)
     */
  /* void onStopRequest (in nsIRequest request, in nsISupports ctxt, in nsresult statusCode, in wstring statusText); */
  NS_IMETHOD OnStopRequest(nsIRequest *request, nsISupports *ctxt, nsresult statusCode, const PRUnichar *statusText) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISTREAMOBSERVER \
  NS_IMETHOD OnStartRequest(nsIRequest *request, nsISupports *ctxt); \
  NS_IMETHOD OnStopRequest(nsIRequest *request, nsISupports *ctxt, nsresult statusCode, const PRUnichar *statusText); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISTREAMOBSERVER(_to) \
  NS_IMETHOD OnStartRequest(nsIRequest *request, nsISupports *ctxt) { return _to ## OnStartRequest(request, ctxt); } \
  NS_IMETHOD OnStopRequest(nsIRequest *request, nsISupports *ctxt, nsresult statusCode, const PRUnichar *statusText) { return _to ## OnStopRequest(request, ctxt, statusCode, statusText); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsStreamObserver : public nsIStreamObserver
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSISTREAMOBSERVER

  nsStreamObserver();
  virtual ~nsStreamObserver();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsStreamObserver, nsIStreamObserver)

nsStreamObserver::nsStreamObserver()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsStreamObserver::~nsStreamObserver()
{
  /* destructor code */
}

/* void onStartRequest (in nsIRequest request, in nsISupports ctxt); */
NS_IMETHODIMP nsStreamObserver::OnStartRequest(nsIRequest *request, nsISupports *ctxt)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onStopRequest (in nsIRequest request, in nsISupports ctxt, in nsresult statusCode, in wstring statusText); */
NS_IMETHODIMP nsStreamObserver::OnStopRequest(nsIRequest *request, nsISupports *ctxt, nsresult statusCode, const PRUnichar *statusText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIStreamObserverProxy */
#define NS_ISTREAMOBSERVERPROXY_IID_STR "3c9b532e-db84-4ecf-aa6a-4d38a9c4c5f0"

#define NS_ISTREAMOBSERVERPROXY_IID \
  {0x3c9b532e, 0xdb84, 0x4ecf, \
    { 0xaa, 0x6a, 0x4d, 0x38, 0xa9, 0xc4, 0xc5, 0xf0 }}

/**
 * A stream observer proxy is used to ship data over to another thread specified
 * by the thread's event queue. The "true" stream observer's methods are 
 * invoked on the other thread.
 *
 * This interface only provides the initialization needed after construction. Otherwise,
 * these objects are used simply as nsIStreamObserver's.
 */
class NS_NO_VTABLE nsIStreamObserverProxy : public nsIStreamObserver {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISTREAMOBSERVERPROXY_IID)

  /**
     * Initializes an nsIStreamObserverProxy.
     *
     * @param observer - receives observer notifications on the other thread
     * @param eventQ - may be NULL indicating the calling thread's event queue
     */
  /* void init (in nsIStreamObserver observer, in nsIEventQueue eventQ); */
  NS_IMETHOD Init(nsIStreamObserver *observer, nsIEventQueue *eventQ) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISTREAMOBSERVERPROXY \
  NS_IMETHOD Init(nsIStreamObserver *observer, nsIEventQueue *eventQ); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISTREAMOBSERVERPROXY(_to) \
  NS_IMETHOD Init(nsIStreamObserver *observer, nsIEventQueue *eventQ) { return _to ## Init(observer, eventQ); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsStreamObserverProxy : public nsIStreamObserverProxy
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSISTREAMOBSERVERPROXY

  nsStreamObserverProxy();
  virtual ~nsStreamObserverProxy();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsStreamObserverProxy, nsIStreamObserverProxy)

nsStreamObserverProxy::nsStreamObserverProxy()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsStreamObserverProxy::~nsStreamObserverProxy()
{
  /* destructor code */
}

/* void init (in nsIStreamObserver observer, in nsIEventQueue eventQ); */
NS_IMETHODIMP nsStreamObserverProxy::Init(nsIStreamObserver *observer, nsIEventQueue *eventQ)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIAsyncStreamObserver */
#define NS_IASYNCSTREAMOBSERVER_IID_STR "a28dc590-91b3-11d3-8cd9-0060b0fc14a3"

#define NS_IASYNCSTREAMOBSERVER_IID \
  {0xa28dc590, 0x91b3, 0x11d3, \
    { 0x8c, 0xd9, 0x00, 0x60, 0xb0, 0xfc, 0x14, 0xa3 }}

/**
 * An asynchronous stream observer is used to ship data over to another thread specified
 * by the thread's event queue. The receiver stream observer is then used to receive
 * the notifications on the other thread. 
 *
 * This interface only provides the initialization needed after construction. Otherwise,
 * these objects are used simply as nsIStreamObservers.
 */
class NS_NO_VTABLE nsIAsyncStreamObserver : public nsIStreamObserver {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IASYNCSTREAMOBSERVER_IID)

  /**
     * Initializes an nsIAsyncStreamObserver. 
     * @param eventQueue - may be null indicating the calling thread's event queue
     */
  /* void init (in nsIStreamObserver receiver, in nsIEventQueue eventQueue); */
  NS_IMETHOD Init(nsIStreamObserver *receiver, nsIEventQueue *eventQueue) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIASYNCSTREAMOBSERVER \
  NS_IMETHOD Init(nsIStreamObserver *receiver, nsIEventQueue *eventQueue); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIASYNCSTREAMOBSERVER(_to) \
  NS_IMETHOD Init(nsIStreamObserver *receiver, nsIEventQueue *eventQueue) { return _to ## Init(receiver, eventQueue); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsAsyncStreamObserver : public nsIAsyncStreamObserver
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIASYNCSTREAMOBSERVER

  nsAsyncStreamObserver();
  virtual ~nsAsyncStreamObserver();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsAsyncStreamObserver, nsIAsyncStreamObserver)

nsAsyncStreamObserver::nsAsyncStreamObserver()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsAsyncStreamObserver::~nsAsyncStreamObserver()
{
  /* destructor code */
}

/* void init (in nsIStreamObserver receiver, in nsIEventQueue eventQueue); */
NS_IMETHODIMP nsAsyncStreamObserver::Init(nsIStreamObserver *receiver, nsIEventQueue *eventQueue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif

// Generic status codes for OnStopRequest:
#define NS_BINDING_SUCCEEDED NS_OK
#define NS_BINDING_FAILED    NS_ERROR_GENERATE_FAILURE(NS_ERROR_MODULE_NETWORK, 1)
#define NS_BINDING_ABORTED   NS_ERROR_GENERATE_FAILURE(NS_ERROR_MODULE_NETWORK, 2)

#endif /* __gen_nsIStreamObserver_h__ */
